Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/HeuristicLab.Problems.BinPacking-3.3.csproj
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/HeuristicLab.Problems.BinPacking-3.3.csproj	(revision 9592)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/HeuristicLab.Problems.BinPacking-3.3.csproj	(revision 9593)
@@ -166,15 +166,13 @@
     <Compile Include="Analyzers\BinPackingAnalyzer.cs" />
     <Compile Include="Decoders\2D\BL\BottomLeftMultiComponentVectorDecoder.cs" />
-    <Compile Include="Decoders\2D\BL\BottomLeftFunctions.cs" />
+    <Compile Include="Decoders\2D\TwoDimensionalPackingFunctions.cs" />
     <Compile Include="Decoders\2D\EP\ExtremePointGroupingVectorDecoder2D.cs" />
     <Compile Include="Decoders\2D\EP\ExtremePointMultiComponentVectorDecoder2D.cs" />
     <Compile Include="Decoders\2D\EP\ExtremePointPackingSequenceDecoder2D.cs" />
-    <Compile Include="Decoders\2D\EP\ExtremePointsFunctions2D.cs" />
+    <Compile Include="Decoders\3D\ThreeDimensionalPackingFunctions.cs" />
     <Compile Include="Decoders\3D\EP\ExtremePointMultiComponentVectorDecoder3D.cs" />
     <Compile Include="Decoders\3D\EP\ExtremePointGroupingVectorDecoder3D.cs" />
     <Compile Include="Decoders\3D\EP\ExtremePointPackingSequenceDecoder3D.cs" />
     <Compile Include="Decoders\3D\DBL\DeepestBottomLeftMultiComponentVectorDecoder.cs" />
-    <Compile Include="Decoders\3D\DBL\DeepestBottomLeftFunctions.cs" />
-    <Compile Include="Decoders\3D\EP\ExtremePointsFunctions3D.cs" />
     <Compile Include="Decoders\3D\DBL\DeepestBottomLeftGroupingVectorDecoder.cs" />
     <Compile Include="Decoders\2D\BL\BottomLeftGroupingVectorDecoder.cs" />
@@ -182,5 +180,11 @@
     <Compile Include="Decoders\2D\BL\BottomLeftPackingSequenceDecoder.cs" />
     <Compile Include="Decoders\3D\EP\ISOContainerMultiComponentVectorDecoder3D.cs" />
+    <Compile Include="Decoders\SequentialPackingFunctions.cs">
+      <SubType>Code</SubType>
+    </Compile>
     <Compile Include="Decoders\PackingSolutionDecoder.cs" />
+    <Compile Include="Dimensions\OccupiedPoints3D.cs" />
+    <Compile Include="Dimensions\OccupiedPoints2D.cs" />
+    <Compile Include="Dimensions\OccupiedPoints.cs" />
     <Compile Include="Encodings\GroupingVector\GroupingVectorSwap2Manipulator.cs" />
     <Compile Include="Encodings\GroupingVector\GroupingVectorSinglePointCrossover.cs" />
@@ -243,6 +247,5 @@
     <Compile Include="Encodings\PackingSequence\Moves\Insertion\InsertionMoveAttribute.cs" />
     <Compile Include="Encodings\PackingSequence\Moves\Insertion\InsertionMoveGenerator.cs" />
-    <Compile Include="Encodings\PackingSequence\PackingSequenceInsertionManipulator.cs" />
-    <Compile Include="Encodings\PackingSequence\PackingSequenceSwap2Manipulator.cs" />
+    <Compile Include="Encodings\PackingSequence\PackingSequenceInversionManipulator.cs" />
     <Compile Include="Encodings\PackingSequence\PackingSequencePartiallyMatchedCrossover.cs" />
     <Compile Include="Encodings\PackingSequence\PackingSequenceOrderCrossover.cs" />
@@ -268,4 +271,5 @@
     </Compile>
     <Compile Include="Encodings\PackingSequence\PackingSequenceRandomCreator.cs" />
+    <Compile Include="Encodings\PackingSequence\PackingSequenceScrambleManipulator.cs" />
     <Compile Include="Encodings\PackingSolutionCreator.cs" />
     <Compile Include="Encodings\PackingSolutionCrossover.cs" />
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Plugin.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Plugin.cs	(revision 9592)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Plugin.cs	(revision 9593)
@@ -26,5 +26,5 @@
   /// Plugin class for HeuristicLab.Problems.BinPacking plugin.
   /// </summary>
-  [Plugin("HeuristicLab.Problems.BinPacking", "3.3.7.9495")]
+  [Plugin("HeuristicLab.Problems.BinPacking", "3.3.7.9563")]
   [PluginFile("HeuristicLab.Problems.BinPacking-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Common", "3.3")]
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Shapes/CuboidPackingShape.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Shapes/CuboidPackingShape.cs	(revision 9592)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Shapes/CuboidPackingShape.cs	(revision 9593)
@@ -53,5 +53,6 @@
 
     #region Helpers
-    public int MultipliedMeasures { get { return Width * Height * Depth; } }
+    public override ThreeDimensionalPacking Origin { get { return new ThreeDimensionalPacking(0, 0, 0, 0); } }
+    public override int MultipliedMeasures { get { return Width * Height * Depth; } }
    
     public override bool Encloses(ThreeDimensionalPacking checkedPosition, PackingShape<ThreeDimensionalPacking> checkedShape) {
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Shapes/PackingShape.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Shapes/PackingShape.cs	(revision 9592)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Shapes/PackingShape.cs	(revision 9593)
@@ -43,4 +43,6 @@
     public abstract void InitializeFromMeasures(int[] measures);
     public abstract int[] ToArray();
+    public abstract int MultipliedMeasures { get; }
+    public abstract D Origin { get; }
 
     public PackingShape(int[] measures) {
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Shapes/RectangularPackingShape.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Shapes/RectangularPackingShape.cs	(revision 9592)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Shapes/RectangularPackingShape.cs	(revision 9593)
@@ -48,5 +48,6 @@
 
     #region Helpers
-    public int MultipliedMeasures { get { return Height * Width; } }
+    public override TwoDimensionalPacking Origin { get { return new TwoDimensionalPacking(0, 0, 0); } }
+    public override int MultipliedMeasures { get { return Height * Width; } }
 
     public override bool Encloses(TwoDimensionalPacking checkedPosition, PackingShape<TwoDimensionalPacking> checkedShape) {
